Welcome to LEADTOOLS Image Categories Help

For WIN32 [image] by LEAD Technologies, Inc. Version 14

Click the [image] toolbar button to widen this window.

Click the Help Topics toolbar button again to display the Table of Contents with the following tabs:

Contents Tab

Click the Contents tab to list the Table of Contents in the left window for this electronic help file.

To open a closed book [image], double-click it or click the Plus symbol

Its contents are listed.

To close an open book [image], double-click it or click the Minus symbol

To open a topic [image], click it. Its contents are displayed.

Index Tab

Click the Index tab to view a list of all headings and index terms in an alphabetical format.

Enter the beginning letters of the desired term. All index terms starting with those letters are displayed.

To go directly to the text for a term, double-click the term, or click the term and then click Display.

Search Tab

Click the Search tab to find a specific term or a list of terms with the same beginning letters.

Enter the beginning letters of the desired word. The system will display all of the words in the help file starting with those letters. All words are case sensitive. Click the desired word to display all of the topics containing that word.

To go directly to the text for a term, double-click the term, or click the term and then click Display.

Topic Toolbar Buttons

Click this button | To do this
Help Topics | Return to the Help Topics Contents tab.
Back | Return to the previous help screen.
Print | Print a displayed topic.
<< | Go back to the prior help topic.
>> | Move to the next help topic.


Annotations

(Document/Medical toolkits only) LEADTOOLS offers a variety of annotation (document markup) options that can be added to document, grayscale and color images. LEADTOOLS allows the end-user to reposition nodes of an existing free-hand object, which prevents the user from redrawing the object. Enhanced redact objects allow you to restore parts of an image that were blacked out. When combined with annotation security, these redact objects provide a means of granting user-level access to parts of an image. Annotation objects can be stored as a separate object layer, or can be burned or embedded into the actual image. LEADTOOLS allows you to read or write annotations as an external file or as a Wang annotation tag within a TIFF file. With LEADTOOLS, you can choose between low level access to the annotations, or you can implement annotation support through a fully automated mode with a ready to use floating, customizable toolbar and pop-up menus. The superior annotation features provided in LEADTOOLS can be used in any application where image markup is required.

With LEADTOOLS Document/Medical Annotation support you can:

  • Create any of the following objects: line, arrow, rectangle, ellipse, polygon, freehand line, text, highlighter, hot spot, note, stamp, redaction, button, audio clip, video, freehand hot spots, points, protractors, cross-products, push pins, and rubber stamps.
  • Implement automated annotation support.
  • Implement annotation passwords (case-sensitive) providing security for every object.
  • Implement hyperlinks for every object. Hyperlinks can be user defined messages, programs to run, or jumps to Web pages.
  • Modify text strings used in automated annotation support.
  • Scale and position a group to fit the displayed bitmap.
  • Group and ungroup objects.
  • Apply an object or group to a bitmap.
  • Size and position an object or group.
  • Rotate an object or group.
  • Flip, reverse, or shear an object or group.
  • Save an object or group on the Windows clipboard.
  • Print an object or group.
  • Save an object or group in a file.
  • Save annotations as an external LEAD file, WMF file, or as a WANG compatible tag inside a TIFF file.
  • [DLL only] Save an object or group as a file in memory. (This is useful for database support.)
  • [ActiveX only] Save an object or group in a database using Visual Basic data binding.


Color Conversion

LEADTOOLS makes it possible to expand or reduce an image's color depth, from 1-bit to 32-bit, with multiple dithering methods using various palette options. Programmers can choose from 8 different dithering methods including Floyd Stein, Burkes, Ordered dithering, Color reduction, Stucki, Stephens, Sierra and Jarvis. Flexible palette options include LEAD's fixed palette, an auto-optimized palette, or a user defined palette. Images can be separated and/or reconstructed to/from individual RGB, CMYK, CMY, HSV, YUV and HSL color planes. When working with 12 and 16 bit grayscale images, LEADTOOLS' window leveling allows you to select the desired range of bits to be used for display or processing. (available in the LEADTOOLS Medical Imaging) All of these options give you the flexibility to make your images look just right for your application, whether you are working with medical images, scanned documents or digital photographs.

Images that are less than 16 bits per pixel require a palette, which is an array of color values. The value of each pixel in one of these images is an index into the palette. (Images that are 16 bits per pixel or higher store the color values directly in the image, as pixel values.)

The number of colors in a palette is limited to the highest possible index value. For example, if an image is 8 bits per pixel, it can have a palette of 256 colors, which is the number of different colors that can be referenced by using the pixel values as 8-bit indexes.

If an image file is less than 16 bits per pixel, the file contains a palette, and when you load the image into a bitmap, the palette is also loaded into the bitmap handle.

Whenever you reduce a bitmap to less than 16 bits per pixel, a palette must be specified or created. You can do any of the following:

  • Let LEADTOOLS create a palette that is optimized for the particular image. (As an option, this palette can include the system identity palette.)

  • Specify a fixed palette, which is the same for all images that use it. The palette can be LEAD's fixed palette or the Netscape fixed palette.

  • Specify a palette of any size that you have created. In creating your own palette, you can let LEADTOOLS do part of the work. For example, you can fill in part of the palette, and let LEADTOOLS fill the rest with optimized colors.

  • Modify the colors in the bitmap palette.

  • Copy a palette from a device context.

  • [DLL only] Use a table to increase the efficiency of the palette that you define.

  • [Medical Imaging only] Use window leveling to map grayscale intensities by specifying the bit range and/or a user defined color map.


Compression

LEADTOOLS offers more compression options than any other toolkit on the market. LEADTOOLS supports industry standard compression algorithms such as JPEG, CCITT G3/G4, Huffman, Arithmetic, RLE, LZW and ZIPLIB, as well as LEAD’s own proprietary CMP compression. In the LEADTOOLS Document/Medical versions, you will find the fastest software only JPEG algorithms available. With the compression options available in LEADTOOLS your application will execute faster, images will use less storage space, and your transfer costs will be reduced. With LEAD's CMP compression, you will get even smaller file sizes while maintaining better image quality than the industry standard compression formats allow.


Database Imaging

LEADTOOLS has specific features designed for the imaging database developer. VB data binding allows you to use the Visual Basic JET engine to store and retrieve image to/from any database supported by JET. LEADTOOLS has support for 32-bit ODBC, which allows you to work with any ODBC database. LEADTOOLS provides a customized OLE 2.0 in-place server which can store and retrieve images into/from any OLE client. Load/Save memory and Load/Save file offset functions provide low-level methods for working with databases.

You can use the database features to store images in any of the file formats supported by LEADTOOLS. LEADTOOLS' database support includes a wide variety of callback routines and features multipage support. These features, when combined with the excellent compression options available in LEADTOOLS, provide a solid base for building robust database applications such as those used in fields like Real Estate, Law Enforcement and Internet on-line shopping.

You can maintain images in a database, using any valid file format to store an image in a long binary field. You can do so as follows:

  • [ActiveX32 and VCL only] Use Open Database Connectivity (ODBC).
  • [ActiveX32 only] Use OLE DB.
  • [ActiveX with Visual Basic and VCL only] Use data binding.
  • Use functions to read files from memory and write files to memory.
  • [DLL and ActiveX] Use LEAD OLE server to embed or link images in any database that supports an OLE field.


Display

Display - LEADTOOLS renders an image of any color depth (1 to 32 bit) to any display device, automatically handling any color reduction or expansion. Intensity, contrast and gamma correction changes can be applied to the display without affecting the original data. Images can be automatically dithered to match the output display device on the fly, without changing the image in memory. Images can be scaled, zoomed, or scrolled when displayed. You can render images with a color specified as transparent.

You can position the displayed image, and zoom in or out by scaling and cropping the display. The rotated display feature (Document/Medical toolkits only) allows rendering images rotated in 90-degree increments without changing the image in memory. Large 1-bit images can remain compressed in memory while decompressing only the portion needed for display. On a 256-color device, you can use a fixed palette option to eliminate palette shifting when displaying more than one image at a time in your application. Many images displayed in the main window may require scrolling. To display a scaled view of such a bitmap, you can use a PanWindow.

LEADTOOLS also lets you display and manipulate a list of images using the ImageList Control. In addition, LEADTOOLS provides a thumbnail browser for browsing entire directories for image files supported by LEADTOOLS.

LEADTOOLS Document/Medical toolkits include specialized display filters including favor black and scale to gray, which allow you to enhance and "clean up" 1 bit images. LEADTOOLS Medical Imaging display support adds 9-16 bit grayscale, and 12 and 16 bit display with window leveling.

When painting images on any video device, you can do the following:

  • Get and set properties that control the behavior of the LEAD control.
  • Control the brightness, contrast, and gamma correction when painting (without affecting the bitmap).
  • Get the client area of the LEAD control.
  • Define the client area as a display surface where you can use Windows graphics device interface (GDI) functions for drawing or adding text.
  • [ActiveX and VCL only] Display a rubberband to mark an area.
  • [ActiveX and VCL only] Zoom in on a selected area.
  • Force repainting of the image in a LEAD control.
  • Scale and position the image. This lets you zoom in or out, fit the image to a window, and position the image in a window.
  • Limit the area to be painted by specifying the source and destination cropping areas.
  • Apply special effects.
  • Apply ROP codes, which determine how to interact with the existing image on the screen.
  • [DLL only] Use a buffer as the source to paint from.
  • [DLL only] Specify an option for fast painting (without device error checking).

If the display mode is 256 colors or less, you can do the following:

  • Use the palette in the bitmap handle or use a fixed palette. You can specify LEAD's fixed palette or the Netscape fixed palette.
  • Specify the dithering method, for images that have more bits per pixel than the current video mode. The following are possible options:
  • Normal dithering (using error diffusion).
  • Ordered dithering, which is faster but less accurate than normal.
  • [DLL only] No dithering, which relies on the display device for color reduction.

For displaying 1-bit (black-and-white) images, you can do the following to enhance the quality of display:

  • [Document/Medical only] Specify a scale-to-gray option, which increases the clarity of the 1-bit images when they are scaled (zoomed in or zoomed out).
  • [Document/Medical only] Specify a favor-black option, which prevents loss of details, such as fine lines, when an image is scaled down (zoomed out).


FlashPix Extension

The LEADTOOLS FlashPix Module is included free of charge in all Document/Medical version toolkits and is offered as an add-on to non-Document/Medical Pro version toolkits

The FlashPix Module extends the input/output functionality in LEADTOOLS by providing increased versatility in the handling of color and grayscale images by taking advantage of the complete FlashPix file structure. FlashPix is a newly emerging file format sponsored by Kodak, Microsoft, Hewlett-Packard, and many other industry leaders. LEAD has been asked by this industry group to add the format to LEADTOOLS, and to join the group in supporting this new image format technology. Features of the module include working with non-image data, loading and saving a portion of an image, working with thumbnail images in a FlashPix file, and working with transformation parameters in an existing FlashPix file.


Image Format Import/Export filters

LEADTOOLS provides support for over 60 of the most popular raster image file formats and flavors.

Here is a list of some of the file formats and some of the flavors LEAD supports: JPEG, DICOM, FlashPix (FPX), Fuji Exif 2.0 (EXF), Adobe PhotoShop (PSD), Kodak PhotoCD PCD, EPS, IOCA, MODCA, CALS raster (CAL), Windows Icon (ICO), Windows Cursor (CUR), PC Paintbrush (PCX), Multipage PCX (DCX), IMG, Windows DIB, FAXraw, Winfax (WFX), MAC, VDA, GIF (Embedded Text, Animated, Interlaced, Transparency), CompuServe PNG, Targa (TGA), Sun Raster (RAS), Macintosh PICT (PCT), LEAD CMP, Windows BMP, OS/2 BMP, Microsoft FAX (AWD), Windows Metafile (WMF), WordPerfect (WPG), AVI, Microsoft Paint (MSP), TIFF 6.0 (MPT, JPEG, Packbits, Huffman, RLE, LZW, CMYK, CCITT, CCITT G31D, CCITT G32D, CCITT G4, Bitonal, Grayscale, Palletized, RGB, YCbCr, CIELAB).

LEAD is constantly adding the support for new file formats, and "flavor" support to formats already supported. The extensive format support provided by LEADTOOLS will give your application the flexibility to support almost any image you encounter.

Visit LEAD’s website at http://www.leadtools.com/formats.htm for a complete list of LEADTOOLS’ file format support.

(Note: a separate patent license from Unisys is required to use the GIF and TIFF LZW filters)


Image Processing

LEADTOOLS has over 60 image processing functions, some of which are typically found only in high performance end-user programs such as PhotoShop. The image processing functions are separated into four categories:

Transforms: LEADTOOLS transforms include resize, resample (interpolated resize), rotate (.01 degree), flip, invert, reverse, crop, underlay, shear, transpose, fill, auto deskew and combine bitmap (using your choice of mathematical and Boolean operations).

Filters: LEADTOOLS color filters include sharpen, blur, intensity, contrast, gamma correct, invert, hue and saturation, histogram equalize, emboss, mosaic, posterize, median, average, oilify, edge enhance, solarize, despeckle, and add noise. LEADTOOLS spatial filters (which can be pre-defined or user-defined) include gradient, laplacian, sobel, prewitt, shift and difference, line segment. LEADTOOLS binary filters include erosion, dilation, max and min.

Drawing: With the LEAD DeviceContext, LEADTOOLS gives you access to the bitmap surface, on which you can draw or paint using Microsoft Windows GDI functions (such as TextOut, BitBlt, Ellipse, and Rectangle).

Region of Interest: The LEADTOOLS region of interest makes it possible for you to process or paint only a specific portion of an image rather than the entire image. Regions can be comprised of any combination of rectangles, ellipses, rounded-rectangles, freehand shapes, polygons, transparent color and more.

Most of the LEADTOOLS functions that change the appearance of an image act on the bitmap (not just the display). This is an important distinction, because the changes become permanent when the bitmap is saved to a file.

To change the appearance of the image in a bitmap, you can do the following:

  • Define the bitmap as a display surface where you can use Windows graphics device interface (GDI) functions for drawing or adding text.
  • [Document/Medical only] Automatically straighten (deskew) a 1-bit image.
  • [Document/Medical only] Remove specks (despeckle) a 1-bit image.
  • Automatically trim a bitmap to remove blank space around the edges.
  • Rotate the image. (Angles can be precise to 100th of a degree.)
  • [Document/Medical only] Do fast rotation in 90-degree increments.
  • Shear the image in the fashion of a parallelogram. (Angles are precise to 100th of a degree.)
  • Change the orientation by flipping the image horizontally or vertically.

Adjust colors and intensities as follows:

  • Change brightness using a flat scale.
  • Change brightness using gamma correction.
  • Change contrast.
  • Stretch the range of intensities.
  • Remap intensities using a lookup table.
  • Invert colors.
  • Change hue and saturation.
  • Histogram equalize.
  • Fill with a specified color.
  • Get and put colors of individual pixels.
  • Apply the following kinds of conversions:
  • Halftone for display or printing.
  • Sharpen or blur.
  • Posterize, specifying the number of color planes.
  • Mosaic, specifying the tile size.
  • Emboss, specifying the lighting direction.
  • Soften an image using an average filter.
  • Reduce noise using a median filter.
  • Add noise in any or all color planes.
  • Apply an oil-painting effect.
  • Apply a solarization effect.

Apply filters to do the following:

  • Detect ranges of intensity.
  • Detect edges using gradient or Laplacian edge detection.
  • Detect lines using Sobel, Prewitt, shift and difference, or line segment detection.
  • [Document/Medical only] Apply morphological (binary) filters to erode or dilate black objects.
  • [DLL only] Implement your own spatial filters.
  • Combine images using boolean and arithmetic operators, and color masking. (This is useful for combining filtered images with originals.)
  • Combine two images so that one appears to be an underlying texture of the other.
  • Combine multiple images to create a new image that resembles the current image.

Use low-level functions to change parts of an image as follows:

  • Get and put rows of image data.
  • Get and put parts of rows.
  • Get and put the colors of individual pixels.
  • Process a region within a bitmap


Internet/Intranet Imaging

LEADTOOLS features a Net Aware ActiveX, COM objects and .NET classes for Internet/intranet applications. The ActiveX and COM include a BitmapDataPath feature, which allows images to be read from any URL. The ActiveX also includes an AnnDataPath feature, which allows LEADTOOLS annotation files to be loaded from any URL. LEADTOOLS includes support for Progressive JPEG, Progressive CMP, PNG and interlaced GIF, so you can display images as they are downloaded. GIF support also includes transparency, animation, and embedded text. The GIF code has support for 1 through 8 bits per pixel files. A FeedLoad function is included to allow image data to be displayed as it is being transmitted across the net, providing Internet programmers with the fastest way to begin painting the client’s screen. Examples for VB script and Java script are included to assist you in incorporating images into Internet applications.

LEADTOOLS lets you do the following when working with the Internet:

  • [ActiveX, COM and VCL only] Use the ActiveX control's net-aware capabilities to load a bitmap asynchronously over the Internet. You can do this by specifying the URL in a single property.

  • Control how data is fed to a load routine.

  • Handle progressive reading and writing of JPEG and LEAD CMP files.

  • Handle transparency, interlaced formatting, and text in GIF files.

  • Create and maintain lists of bitmaps that are used for animation.

  • Create and play animations, read and write animated GIF files, and read AVI files.

  • Read and write most other image file formats that are transmitted on the Internet.


JBIG Module

(JBIG Module is an add-on for Document/Medical [version 10 and higher] toolkits) LEAD offers an optional JBIG module as an add-on to any Document/Medical toolkit. JBIG defines a method for lossless compression encoding of a bi-level image (two color image). This method can also be used for coding grayscale and color images. LEADTOOLS now completely supports all three types of images, giving you the ability to make full use of this powerful compression technology. LEADTOOLS also supports the progressive capability of JBIG, allowing you to store and send multiple representations of images at different resolutions without any extra storage overhead.

To achieve the highest compression ratios available in the JBIG format, LEAD now takes full advantage of all the functional blocks of this robust standard:

  • The Adaptive Arithmetic Encoder , which presents the heart of this format, has the ability to predict and hence encode future data symbols based on the data which is being currently encoded.
  • The Adaptive Template Block provides real coding gain for images rendered by grayscale with halftoning. This gain ratio approaches 80% in some situations.
  • The Typical Prediction Block speeds implementations and provides some coding gain.
  • The Resolution Reduction Block is used to get a lower resolution version of an image so that no loss of data is encountered. This is mainly important for bi-level images, to avoid any deletion of thin lines.
  • The Deterministic Prediction Block provides good coding gain when saving more than one resolution layer in the same file.

All the free parameters specified by the JBIG standard are applied in LEAD to achieve maximal compression and the highest speed for any saving or loading operation.


LEADTOOLS Imaging Common Dialogs

The LEADTOOLS Common Dialog boxes greatly simplify development and save hours of tedious programming by extending Windows common dialogs to provide imaging specific capabilities. The Common Dialog boxes provide complete code for all common imaging dialogs such as image processing, conversion and effects. Thumbnail previewing of image changes saves processing time and avoids un-dos.

The LEADTOOLS Common Dialog libraries provide a set of common dialog boxes that combine Windows Common Dialog functionality with LEADTOOLS imaging functionality. Common Dialogs are provided for FileOpen, FileSave, Color Resolution, Image Processing/Filtering, and Effects. You can specify your own String and/or Text, as well as handle Language Customization – This is a great feature for localizing your software for International users.

The LEADTOOLS Imaging Common Dialogs also provide input dialog boxes for all of the LEADTOOLS image processing functions. These dialogs allow you to quickly and easily enable your application to gather input from end-users for the parameters required by the various LEADTOOLS functions. These dialogs can also be used to automatically process the image based on end-user input (thus reducing the amount of code you have to write).

The dialog functions feature:

  • Reusable dialogs for the most common LEADTOOLS image processing functions and effects.
  • Extending FileOpen and FileSave dialogs which contain LEADTOOLS specific options.
  • Thumbnail Preview option for FileOpen dialog allows the user to preview images without loading them.
  • Thumbnail Preview for image processing dialogs allows the user to preview the change without actually affecting the original image.
  • An optional Help Button callback function lets you provide custom help information for each dialog.
  • User Interface control for the dialogs is provided through flags passed to each dialog function or method.
  • Optional Automatic processing of the image by the dialog.


Medical Communications

(Available in Medical toolkits) LEADTOOLS provides extensive support for the DICOM Communication Protocol. This protocol outlines the requirements for transferring DICOM data and messages across an associated network connection. For more information about the DICOM Communication Protocol, refer to LEADTOOLS DICOM Network Communication Support for Message Exchange, or the DICOM Standard in the DICOM Help Files (Ltdicdlln.hlp, Ltdicocxn.hlp, Ltdiclibn.hlp), located in the \Help\ directory.

With LEADTOOLS you can create an Application Entity (AE) that serves as either the Service Class Provider (SCP), Service Class User (SCU), or both.

With this support you can do the following:

Create/Manage/Destroy DICOM Network connections (secure or un-secure)

Send DICOM messages

Receive DICOM messages

LEADTOOLS supports the following security modes for DICOM Network connections:

No security mode – un-secure

Integrated Secure Communication Layer protocol security - ISCL

Transport Layer Secure protocol security – TLS


Medical Imaging

(Available in Document/Medical toolkits) LEADTOOLS provides extensive support for DICOM 3.0 files(all classes/modalities DICOMDIR, CR, CT, MR, NM, US, RF, SC, VL, etc.) in the Medical Imaging toolkit, allowing you to create and save new DICOM files, or read, modify and save existing DICOM files.

With this support you can do the following:

  • Create, Initialize, Load, and Save Data Sets.
  • Maneuvering Through a Data Set.
  • Search a Data Set.
  • Insert and Delete Data Set Members.
  • Get and Set Data Element Values.
  • Get and Set Data Set Information.
  • Get, Set and Insert Single or Multiframe Images (compressed or uncompressed)
  • Maneuver Through the IOD Table.
  • Search the IOD Table.
  • Insert and Delete IODs.
  • Modify an Existing IOD.
  • Set the Default IOD Table.
  • Maneuver Through the Data Element TagTable.
  • Search the Data Element Tag Table.
  • Insert and Delete Tags.
  • Modify an Existing Tag.
  • Set the Default Data Element Tag Table.
  • Maneuver Through the UID Table.
  • Search the UID Table.
  • Insert and Delete UIDs.
  • Modify an Existing UID.
  • Set the Default UID Table.
  • Maneuver Through the Value Representation Table.
  • Search the Value Representation Table.
  • Insert and Delete Value Representations.
  • Modify an Existing Value Representation.
  • Set the Default Value Representation Table.


Multimedia

With LEADTOOLS Multimedia features, editing multimedia/video becomes a breeze. Internet imaging, video email and video conferencing? - no problem. Edit motion video, record video and audio and create video applications. You get Multimedia capabilities - with 3 areas of functionality - Video, Capture, and Internet. Terrific for creating video frames with synchronized sound, editing playing, and saving AVI files, recording, playing and saving WAV files, and playing MIDI, SND, AIF, AIFC, MPEG-1 files. You can easily capture multimedia data from any Windows Video Capture Device, using input such as a VCR, camcorder or digital camera. LEADTOOLS Multimedia lets you stream (progressively play and download) multimedia files such as Microsoft's ActiveMovie and Apple QuickTime, and quickly create client server applications to run over the Internet.

With LEADTOOLS Multimedia support you can:

VIDEO:

  • Play/edit multimedia objects
  • Play/Stop/Pause
  • Set Balance/Volume/Play rate/Time format
  • Edit existing multimedia objects or create new ones
  • Copy/Delete/Insert/Paste/Replace frames/Start/Stop

CAPTURE AUDIO/VIDEO WITH:

  • Streaming with frame rate
  • Single frame
  • Audio (volume, level, formats, and muting)
  • Device selection

INTERNET:

  • Create video, audio and data client server applications including video conferencing over the Internet/Intranet.


OCR

LEADTOOLS' OCR engine includes preset confidence and accuracy levels, artificial intelligence, and built-in and user-defined lexicons for limiting the type of text to recognize within a particular zone. LEADTOOLS provides the ability to verify or correct text during, and (using LEAD's unique OCR editor) after recognition. LEAD's OCR editor ties the text being edited directly to the image, providing a visual reference to the original bitmap data. The OCR engine can perform Automatic area segmentation creating multi-layered zones, recognizing areas such as tables, rules, images and text. Or, you can manually designate up to 250 such zones.

Different fonts, sizes (5 to 72 point) and styles are also supported. Fax, dot matrix and halftones can be preprocessed to improve recognition results. The OCR Engine supports major European and Scandinavian languages (Danish, Dutch, Finnish, French, German, Italian, Norwegian, Portuguese, Russian, Spanish, and Swedish) as well as English. Support for dialects such as US. English, French Canadian, Latin American Spanish, Swiss German, and Brazilian Portuguese is also provided. Recognized text can be exported to more than 40 different formats, including MS Word, MS Excel, Dbase and WordPerfect. You get superior OCR processing speeds, for use in form recognition and processing applications. The OCR features extend the functionality of the LEADTOOLS Document Imaging Suite by providing properties, methods, and events for easily incorporating the Xerox TextBridge optical character recognition engine into your applications.

These functions, properties and methods feature:

  • [Document Imaging Suite ActiveX32 only] Recognize and export text, choosing from a variety of text, word processing, database, or spreadsheet file formats.
  • [Document Imaging Suite ActiveX32 only] Select the language of documents to be recognized. Choose from English, Danish, Dutch, Finnish, French, German, Italian, Norwegian, Portuguese, Russian, Spanish, or Swedish.
  • [Document Imaging Suite ActiveX32 only] Segment complex pages manually or automatically into text zones, image zones, table zones, lines, headers and footers.
  • [Document Imaging Suite ActiveX32 only] Set accuracy thresholds prior to recognition to control the accuracy of recognition.
  • [Document Imaging Suite ActiveX32 only] Learn, save and load character recognition data for similar documents. The software learns as a result of normal recognition, and acquires additional information by using the OCR's text verification system.
  • [Document Imaging Suite ActiveX32 only] Recognize text from 5 to 72 points in virtually any typeface.
  • [Document Imaging Suite ActiveX32 only] Increase recognition accuracy with built-in lexical classes and user defined lexicons.
  • [Document Imaging Suite ActiveX32 only] Verify or correct text during the recognition process based on confidence levels set prior to recognition. If a word or character falls within the set range, a dialog box can be brought up to allow the user to see the original image and the preliminary results of the recognition. From the dialog box, the user may make any necessary corrections to the recognized text.
  • [Document Imaging Suite ActiveX32 only] Once recognition is complete, edit the entire document, using the LEADTOOLS OCR Editor.
  • [Document Imaging Suite ActiveX32 only] Automatically detect fax, dot matrix, and other degraded documents and compensate accordingly.
  • [Document Imaging Suite ActiveX32 only] Process both text and halftone graphics. The recognition software's ability to distinguish halftone graphics from text can provide the basis of a compound document processing system.
  • Recognized text can be exported to more than 40 different formats, including MS Word, MS Excel, Dbase and WordPerfect.


Printing

LEADTOOLS performs all image processing necessary to print directly to any Windows supported printer. LEADTOOLS can preprocess the image for you, so it matches the output device, or allow you to manually process the data before printing. With LEADTOOLS, you can print text and multiple images on the same page.


Scanning

LEADTOOLS supports high speed, dual page scanning using both TWAIN and ISIS® industry standards for image acquisition in document (halftone), grayscale or color modes.

LEADTOOLS' TWAIN support includes both 16 & 32 bit native and buffered RAM transfer modes. Developers have the option of using the default TWAIN interface provided by the TWAIN datasource, or they can choose to by-pass the user interface to create their own, as long as the driver supports it. The LEADTOOLS TWAIN functions offer control over image size, position, brightness, contrast, resolution, and orientation. Support for single and multi-page acquire is provided. With LEADTOOLS, your application can acquire images from TWAIN compliant devices such as scanners, capture cards, and digital cameras from manufacturers like Kodak, Hewlett Packard, Microtek, Logitech, Fuji and many more.

With LEADTOOLS’ support for ISIS®, developers can use the driver's built-in dialog box for controlling the image acquisition or by-pass it and create their own. The LEADTOOLS ISIS support functions offer control over image size, position, brightness, contrast, resolution, orientation, gamma and compression. Developers can request compressed data from the ISIS driver, for faster image acquisition. LEADTOOLS supports single page acquire to memory, multipage acquire to multipage file, and multipage acquire to multiple single page files. With LEADTOOLS, your application can acquire images from ISIS compliant scanners from manufacturers like Ricoh, Hewlett Packard, Bell&Howell, and others. You can use images acquired as document (halftone), grayscale or color for use in check & form processing applications, stock photo collections, WebPages and more.

ISIS support is only available in the Document/Medical versions. LEAD does not grant any license to the ISIS driver, or to ISIS development capabilities. It is your responsibility to obtain the appropriate license to cover your development project, either from Pixel Translations, or one of their licensees.


Screen Capture

LEADTOOLS provides functions for capturing all or part of the screen. The result can then be used with any of the LEADTOOLS image processing fuctions and can be saved in any of the more than 60 file formats that LEAD supports.

With the LEADTOOLS Capture feature you can:

  • Capture the entire screen
  • Active window
  • Menu under cursor
  • Window under cursor (button, tool bar, icon, or client area)
  • Selected object
  • Mouse cursor or wallpaper

LEADTOOLS also allows for capture of a selected area of the screen in a wide array of shapes such as:

  • Rectangle
  • Rounded rectangle
  • Ellipse
  • Polygon or freehand
  • Icon

Bitmap and cursor resources can be captured from 16 or 32-bit Windows EXE and DLL files. Options include:

  • Multi-capture with callback
  • Hot Keys
  • Time interval

Great for presentation and application documentation.


Special Effects

LEADTOOLS provides special effects for developing multimedia projects or presentation applications. You can use many paint effects, dissolves, and transitions. Effect options allow you to choose from over 2000 paint effects, 36 gradients, 80 shapes, 12 3-D text styles, 64 dissolves and 43 transition effects with delays, grain sizes, pattern brushes and a colored wand, all with control over the speed and granularity of each effect. You can also draw plain or three-dimensional text and graphic shapes on the screen or on the bitmap.

With the LEADTOOLS special effects you can develop visually stimulating multimedia projects, presentation applications, or enhance websites.

Specifically, you can do the following:

  • Specify an effect that is applied when painting the image from a bitmap.
  • Specify a transition between images, which is an effect that paints a pattern or gradient color (instead of the image from a bitmap).
  • Control the speed, granularity, multiple paint passes, transparent color, and wand usage when painting images or transitions.
  • Specify a transparent color and paint a control with a transparent background.

When drawing shapes or text objects on the screen or on the bitmap, you can do the following:

  • Paint a rectangular area that contains a pattern or gradient color. This is useful for creating a bitmap that can be used as the background of a shape object or the foreground of a text object.
  • Draw a shape with a three-dimensional appearance. The shape can be one of 80 variations of rectangles, triangles, circles, and so forth, or it can be created from an existing Windows region.
  • Draw a text object with a three-dimensional appearance. The text can be rotated with precision to a tenth of a degree.
  • Specify a bitmap to use as the background of a shape, or as the foreground of a text object.
  • Draw a frame with a three-dimensional appearance. (In the ActiveX the frame is applied as a border of the control.)
  • Draw a simple Windows-style line, rectangle, or ellipse, with standard options for the draw-mode, pen, and fill.


Vector Imaging

(Available in Vector Imaging toolkits) LEADTOOLS provides 2-D and 3-D vector imaging for loading, viewing, modifying and saving vector files to memory/disk in native vector format. Formats include DXF (2D and 3D), EMF and WMF. 3D images can be rotated along the 3 standard axis, and painted using different illumination models. Drawings can be attached to a window for dynamic viewing. Viewing perspectives can be changed at runtime. Optimized drawing code can use OpenGL, DirectX or GDI functions. Includes 2D and 3D engine with camera, shades, lighting, resize, rotate, enumerate, select object and more. Vector images can be scaled from 1-1000%. With LEADTOOLS, vector images can also be converted and saved as any of the over 60 raster file formats supported by LEADTOOLS.

To work with vectors and vector handles, you can do the following:

  • Rotate, translate and scale the entire image or selected object(s).
  • Use LEADTOOLS 3D viewing options including lighting, shadow, camera, polygon modes (points, wire-frame, filled).
  • Utilize multiple vector engines (GDI, OpenGL, DirectX).
  • Convert to and from WMF and EMF.
  • Render a vector image to a bitmap handle.


Raster Pro/Document/Medical Features

Raster Pro:

LEADTOOLS Raster Imaging Pro provides some imaging capabilities that are not available in the LEADTOOLS Raster Imaging product. In order to access these features, you must unlock them by calling L_UnlockSupport(L_SUPPORT_LTPRO, L_KEY_LTPRO). L_KEY_LTPRO can be found in ltkey.h.

If you are a licensed user of LEADTOOLS Raster Imaging, and would like to access Raster Imaging Pro features, you must contact Tech Support for information on obtaining a license and the unlock key for calling L_UnlockSupport.

Document/Medical:

LEADTOOLS Document Imaging, LEADTOOLS Document Imaging Suite, LEADTOOLS Medical Imaging and LEADTOOLS Medical Imaging Suite are the most comprehensive imaging toolkits on the market. No other toolkit provides as many imaging features for color, gray-scale and black & white images in one development package, and for one price. These toolkits comprise LEAD's best code and are designed for the programmer who is looking for the fastest performance, and/or the most extensive color, document, and medical imaging capabilities available.

These toolkits contain powerful annotation capabilities and optimized document image processing filters, and high performance compression, decompression and viewing of JPEG, LEAD CMP, MRC and CCITT G3/G4. The annotation capabilities enable the programmer to add text, highlights, sticky notes, audio, ellipses, buttons, lines, arrows, rectangles, polygons, redaction (blackout), hotspots, freehand scribble, pointers, bitmap and text stamps, to black & white and color images. Programmers working with document imaging will also find special processing filters such as despeckle, deskew, favor black, and scale to gray to enhance their black and white 1 bit images. Additionally, you can achieve faster rotation in 90-degree increments by applying a rotated view perspective to the bitmap. These LEADTOOLS toolkits offer the fastest software-only JPEG decoder available.

LEADTOOLS Document Imaging

The LEADTOOLS Document Imaging toolkit contains all the features available in the LEADTOOLS Raster Imaging Pro. In addition, it contains the following capabilities:

Special functions for Document (bitonal) images. The LEADTOOLS functions for bitonal images are especially useful for working with images from black-and-white scanners or FAX machines. These functions let you do things such as automatically straighten (deskew) an image, remove spots (despeckle), or clarify a scaled display (using scale-to-gray and favor-black features).

Annotation. LEADTOOLS supports annotation of images by letting you overlay images with text, lines, shapes, arrows, buttons, highlights, hot spots, sticky notes, stamps, buttons, and sounds.

Fast rotation. LEADTOOLS achieves fast rotation in 90-degree increments by applying a rotated view perspective to the bitmap.

ISIS support. LEADTOOLS supports ISIS interfaces for driving scanning devices.

Faster compression and decompression. The Document/Medical editions work faster when loading and saving LEAD CMP, JPEG, and CCITT Group 3 and Group 4 images. The LEADTOOLS functions for loading and saving are the same in all products. The only difference is in performance.

1-bit Image Clean-up. The Document toolkits include support for removing dots, blobs, holes, inverted text, lines, borders, bumps and nicks from 1-bit images.

Region Clean-up. [Document/Medical] Remove all the holes from a region.

Embedded Messages. The Document toolkits include support for embedding messages in lossless image formats like bmp, tiff, lossless jpeg, etc. The message is embedded without any visible changes to the image, and does not appreciably increase the size of the image. The message is password-protected.

Image Conversion. The Document toolkits include support for transforming a bitmap into a binary image using specified thresholds or a threshold calculated automatically based on statistical features of the bitmap.

12 and 16 bit grayscale images. [Document/Medical] Load, process, display, window level and save 12 and 16 bit grayscale images (including support for 16-bit grayscale TIFF).

48 and 64 bit color images. [Document/Medical] Load, process, display, and save 48 and 64 bit color images.

MRC Support. [Document/Medical] LEADTOOLS supports the Mixed Raster Content format for color documents containing mixed image and text components.

Halftoning. [Document/Medical] Convert 1-, 4-, 8-, 16-, 24-, or 32-bit bitmaps to a halftoned bitmap, with a specified pattern rotation. A halftoned bitmap is a 1-bit bitmap that has been dithered for black and white printing or display.

LEADTOOLS Document Imaging Suite

The LEADTOOLS Document Imaging Suite toolkit contains all the capabilities of LEADTOOLS Document Imaging, and includes the features listed below. Please note that the OCR features are included in this toolkit, however they can also be purchased as a plug-in for the LEADTOOLS Document Imaging toolkit. Also, JBIG support is provided in this toolkit, however a JBIG Module may be added on to LEADTOOLS Document Imaging, LEADTOOLS Medical Imaging or LEADTOOLS Medical Imaging Suite.

OCR features. [Document/Medical] LEAD offers OCR features that use Scansoft Textbridge technology. Support for these features is included in the LEADTOOLS Document Imaging Suite, and can be added, via plug-in to the LEADTOOLS Document Imaging, LEADTOOLS Medical Imaging and LEADTOOLS Medical Imaging Suite toolkits. The OCR features allow you to perform optical character recognition and turn images into documents. Features include preset confidence and accuracy levels for controlling how sensitive the engine is to unrecognized text, artificial intelligence for improving recognition on documents of the same type, and built-in and user-defined lexicons for limiting the type of text to recognize within a particular zone. LEADTOOLS provides the ability to verify or correct text during, and (using LEAD's unique OCR editor) after recognition. LEAD's OCR editor ties the text being edited directly to the image, providing a visual reference to the original bitmap data. The OCR engine can perform Automatic area segmentation creating multi-layered zones, recognizing areas such as tables, rules, images and text. Or, you can manually designate up to 250 such zones. The OCR features support different fonts, sizes (5 to 72 point) and styles. Fax, dot matrix and halftones can be preprocessed to improve recognition results. The OCR Engine supports major European and Scandinavian languages (Danish, Dutch, Finnish, French, German, Italian, Norwegian, Portuguese, Russian, Spanish, and Swedish) as well as English. Support for dialects such as US. English, French Canadian, Latin American Spanish, Swiss German, and Brazilian Portuguese is also provided.

Recognized text can be exported to more than 40 different formats, including MS Word, MS Excel, Dbase andWordPerfect. The LEADTOOLS OCR features contain superior OCR processing speeds, for use in form recognition and processing applications.

LEAD's JBIG filter. [Document/Medical] LEAD includes support for this filter in the LEADTOOLS Document Imaging Suite toolkit. Support for this filter can be added to LEADTOOLS Document Imaging, LEADTOOLS Medical Imaging or LEADTOOLS Medical Imaging Suite by purchasing the JBIG Module. JBIG defines a method for lossless compression encoding of a bi-level image (two-color image). This method can also be used for coding grayscale and color images. LEADTOOLS completely supports all three types of images, giving you the ability to make full use of this powerful compression technology. LEADTOOLS also supports the progressive capability of JBIG, allowing you to store and send multiple representations of images at different resolutions without any extra storage overhead.

LEADTOOLS Medical Imaging

LEADTOOLS Medical Imaging contains all the capabilities of LEADTOOLS Document Imaging. It also includes general medical imaging technologies (1-16,24,32 bit color, 1-16 bit grayscale and window leveling of 12 and 16-bit grayscale images) and support for the DICOM file format.

DICOM file support. [Medical] LEADTOOLS Medical Imaging provides COMPLETE support for the DICOM 3.0 specification, including all standard IOD classes and modalities (CR, CT, MR, NM, US, RF, SC, VL, etc.) and complete DICOM Basic Directory support.

Window leveling. [Document/Medical] Detect and set LowBit and HighBit for image data, display images with automatic LUT intensity expansion, or set LUT entries and ranges with specific values and gradients. Display images through the LUT without changing the data, or process the image data using the LUT. Linearize the number of pixels locally in a bitmap, based on the specified color space in order to bring out the detail in dark areas of an image, and smooth the edges between blocks.

Medical Imaging Processing. [Medical] LEADTOOLS Medical Imaging provides image processing functionality designed specifically to allow you to examine and improve the quality of medical images.

LEADTOOLS Medical Imaging Suite

LEADTOOLS Medical Imaging Suite contains all the capabilities of LEADTOOLS Medical Imaging. In addition, it supports the following:

DICOM Communication support. [Medical Suite] LEADTOOLS provides COMPLETE support for DICOM Communications, including all Service Classes (Verification, Storage, Query/Retrieve, Patient Management, etc), and contains high-level communications functions simplifying the creation of DICOM client/server applications.

(Document/Medical) is used in the documentation to designate the features that are available in LEADTOOLS Document Imaging, LEADTOOLS Document Imaging Suite, LEADTOOLS Medical Imaging and LEADTOOLS Medical Imaging Suite. Those features that are available only in the Medical toolkits are indicated in the documentation by (Medical). Features available only in the LEADTOOLS Medical Imaging Suite toolkit are indicated in the documentation by (Medical Suite).

(Internet only) is used in the documentation to designate the features that are available only in the LEADTOOLS Internet toolkit.